/* Process model C form file: sh_adaptive_mtcp_1.pr.c */
/* Portions of this file copyright 1992-2004 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
const char sh_adaptive_mtcp_1_pr_c [] = "MIL_3_Tfile_Hdr_ 110A 30A opnet 7 45AC07D4 45AC07D4 1 luna momueti 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 b56 1                                                                                                                                                                                                                                                                                                                                                                                                                ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */


/* Header Block */
#include <opnet.h>
#include "ip_higher_proto_reg_sup.h"
#include <ip_dgram_sup.h>
#include <ip_addr_v4.h>
#include <ip_support.h>
#include <oms_dt.h>
#include <tcp_api_v3.h>
#include <tcp_v3.h>
#include <tcp_seg_sup.h>
#include <tcp_support.h>
#include <oms_pr.h>
#include <oms_qm.h>
#include <oms_tan.h>
#include <ip_notif_log_support.h>
#include <ip_rte_v4.h>
#include <ip_qos_support.h>
#include <string.h>


#define TO_ENCAP_STRM 0
#define FROM_ENCAP_STRM 0

/* Define transition macros */
#define PK_ARRIVE (op_intrpt_type() == OPC_INTRPT_STRM)
#define TIME_OUT ((op_intrpt_type() == OPC_INTRPT_REMOTE )|| (op_intrpt_type() == OPC_INTRPT_SELF )) 

int isInit;

static int fh_data_len;

int src_port ;
int dest_port;


unsigned fh_last_seq_num;
unsigned fh_last_ack_num;

// the ack from Mobile host, seen by router, which is
// ack seen by Fixed host plus 1
unsigned mh_last_ack_num;
unsigned mh_last_seq_num;

// shared variables for incoming ip pkt
static IpT_Address		org_addr;
static IpT_Address		dest_addr;
static int 				type_of_service;
static int 				protocol_type;

// to store a sample of the Mobile host packet for later use
Packet * sample_MH_pkt;

int transMode;
int transBeginCycle;
int isBrokenLink;
int generateACK;


// rto for MH
double MH_rto=0.6;

/* End of Header Block */

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Stathandle	             		bits_rcvd_stathandle                            ;
	Stathandle	             		bitssec_rcvd_stathandle                         ;
	Stathandle	             		pkts_rcvd_stathandle                            ;
	Stathandle	             		pktssec_rcvd_stathandle                         ;
	Stathandle	             		ete_delay_stathandle                            ;
	Stathandle	             		bits_rcvd_gstathandle                           ;
	Stathandle	             		bitssec_rcvd_gstathandle                        ;
	Stathandle	             		pkts_rcvd_gstathandle                           ;
	Stathandle	             		pktssec_rcvd_gstathandle                        ;
	Stathandle	             		ete_delay_gstathandle                           ;
	Objid	                  		own_objid                                       ;
	Objid	                  		own_node_objid                                  ;
	OmsT_Pr_Handle	         		own_process_record_handle                       ;
	char	                   		proc_model_name[20]                             ;
	Prohandle	              		own_prohandle                                   ;
	int	                    		higher_layer_protocol_type                      ;
	int	                    		instrm_from_network                             ;
	int	                    		record_handle_list_size                         ;
	} sh_adaptive_mtcp_1_state;

#define pr_state_ptr            		((sh_adaptive_mtcp_1_state*) (OP_SIM_CONTEXT_PTR->_op_mod_state_ptr))
#define bits_rcvd_stathandle    		pr_state_ptr->bits_rcvd_stathandle
#define bitssec_rcvd_stathandle 		pr_state_ptr->bitssec_rcvd_stathandle
#define pkts_rcvd_stathandle    		pr_state_ptr->pkts_rcvd_stathandle
#define pktssec_rcvd_stathandle 		pr_state_ptr->pktssec_rcvd_stathandle
#define ete_delay_stathandle    		pr_state_ptr->ete_delay_stathandle
#define bits_rcvd_gstathandle   		pr_state_ptr->bits_rcvd_gstathandle
#define bitssec_rcvd_gstathandle		pr_state_ptr->bitssec_rcvd_gstathandle
#define pkts_rcvd_gstathandle   		pr_state_ptr->pkts_rcvd_gstathandle
#define pktssec_rcvd_gstathandle		pr_state_ptr->pktssec_rcvd_gstathandle
#define ete_delay_gstathandle   		pr_state_ptr->ete_delay_gstathandle
#define own_objid               		pr_state_ptr->own_objid
#define own_node_objid          		pr_state_ptr->own_node_objid
#define own_process_record_handle		pr_state_ptr->own_process_record_handle
#define proc_model_name         		pr_state_ptr->proc_model_name
#define own_prohandle           		pr_state_ptr->own_prohandle
#define higher_layer_protocol_type		pr_state_ptr->higher_layer_protocol_type
#define instrm_from_network     		pr_state_ptr->instrm_from_network
#define record_handle_list_size 		pr_state_ptr->record_handle_list_size

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#  define FIN_PREAMBLE_DEC	sh_adaptive_mtcp_1_state *op_sv_ptr;
#if defined (OPD_PARALLEL)
#  define FIN_PREAMBLE_CODE	\
		op_sv_ptr = ((sh_adaptive_mtcp_1_state *)(sim_context_ptr->_op_mod_state_ptr));
#else
#  define FIN_PREAMBLE_CODE	op_sv_ptr = pr_state_ptr;
#endif


/* Function Block */


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ };
#endif

/* MTCP Process Function Block */
static IpT_Address org_addr1;
static IpT_Address dest_addr1;

InetT_Address  org_addr2;
InetT_Address  org_addr3;

unsigned ack_num2;
unsigned ack_num3;
int fh_seq_num;

Packet * copy_pkptr5;

typedef struct
	{
	Packet * pkt;
	unsigned seq_num;
	unsigned data_len;
	double arr_time;
	double time_out;
	} QueueItem ;

#define MAXQUEUESIZE 5000

QueueItem queue[MAXQUEUESIZE];

int queueHead=0; /* point to first empty item */
int queueTail=0; /* point to last item */

// ---------beginning of Queue Functions----------

/* Function to keep queue size <= maximum queue size */
int nextQueueIndex( int n )
	{
	if ( n==MAXQUEUESIZE-1 ) n=0;
	else n++;
	
	return n;
	}

/* Function to indicate that queue is empty */
int isQueueEmpty()
	{ 
	return ( queueHead == queueTail );
	}

/* Function to indicate end of queue */
int hasReachedEnd( int n )
	{ 
	return ( n == queueTail );
	}

/* Function to return the current queue size */
int queueSize()
	{ int size = queueTail - queueHead;
	if ( size<0 ) size += MAXQUEUESIZE ;
		return size;
	}

/* Function to queue more packets */
void putInQueue( Packet * pkt, unsigned seq_num, unsigned data_len )
	{
	if ( nextQueueIndex(queueTail) != queueHead ) /* the queue is not full */
		{ queueTail=nextQueueIndex(queueTail);
		queue[queueTail].pkt = pkt;
		queue[queueTail].seq_num = seq_num;
		queue[queueTail].data_len = data_len;
		queue[queueTail].arr_time = op_sim_time();
		}
	}

/* Function to purge packets that have been ACKed by lastAck number */
void purgeFromQueue( unsigned lastAck )
	{
	int nextItem ;
	
	// nothing to purge
	while ( !isQueueEmpty() )
		{
		nextItem = nextQueueIndex( queueHead );
	
		// purge ACKed packet(s)
		if ( queue[nextItem].seq_num + queue[nextItem].data_len <= lastAck )
			{ queueHead = nextItem;
			op_pk_destroy( queue[nextItem].pkt );
			}
		else
		break;
		} 
	}

// Function to re-send all packets that have not reached the destination */
void resendPackets()
	{ 
	int first;
	Packet * pkt;
	
	if ( isQueueEmpty ())
		return; 
	
	first = queueHead ;
	
	while (queueSize()> 0 )
			{
			
			if (ack_num3<=ack_num2)
				{ 
				first = nextQueueIndex (queueHead );
				pkt = op_pk_copy( queue[first].pkt );
			
				// for debug
				printf("Before purging, queue size is [%d], head=[%d], tail=[%d]\n",
queueSize(), queueHead, queueTail );
				printf(" Before purging,the value of ack_num3 is %d \n",ack_num3);	
				
				printf("Sequentially resending packets\n");
				op_pk_send_forced( pkt, TO_ENCAP_STRM ); // sequentially re-send pkts
			
				purgeFromQueue(ack_num3 +1460);
			
				// for debug
				printf("After purging, queue size is [%d], head=[%d], tail=[%d]\n",
queueSize(), queueHead, queueTail );
			
				ack_num3 += 1460;
				printf("After purging,the value of ack_num3 is %d \n",ack_num3);	
				}
			else
				break;
			}
		}

//---------- end of queue functions ---------

/* This function re-calculates the RTO based on the arrival time of ACK packet */
/* When an ACK comes in, we get the send time of the packet from the queue and */
/* decide the RTT of it */
static double calculateRTO( unsigned ack_num, double arrive_time )
	{
	int nextItem =queueHead;
	double rtt;

	// try to find the paket in queue
	while ( !hasReachedEnd( nextItem) )
		{
		nextItem = nextQueueIndex( queueHead );
		// find the ACKed packet(s)
		if ( queue[nextItem].seq_num + queue[nextItem].data_len == ack_num )
			{ // found
			rtt = arrive_time - queue[nextItem].arr_time;
			break;
			}
		} 

	return 0.45; // we return the fixed RTO at this moment
	}


// analyse an incoming packet
static void analyse_incoming_pkt( Packet * ip_pkptr )
	{ 
	IpT_Dgram_Fields* ip_dgram_fd_ptr;
	TcpT_Seg_Fields * tcp_seg_fd_ptr;
	Packet* copy_pkptr3;
	Packet * ipcopy_pkt1;

	FIN (analyse_incoming_pkt(ip_pkptr ))
	
	copy_pkptr3 = op_pk_copy(ip_pkptr);

	// extract the tcp packet out
	if (op_pk_nfd_get (copy_pkptr3, "data", &ipcopy_pkt1) == OPC_COMPCODE_FAILURE)
		{ 
		printf ("modify MH: Unable to get tcp pkt from IP datagram again.\n");
		FOUT 
		}

	// access the tcp packet fields.
	if (op_pk_nfd_access (ipcopy_pkt1, "fields", &tcp_seg_fd_ptr) == OPC_COMPCODE_FAILURE)
		{ 
		printf ("modify MH: Unable to get data from TCP Segment to modify tcp pkt.\n");
		FOUT
		}
	
	/* Determine the TCP source port number */
	src_port = tcp_seg_fd_ptr->src_port;
	
	/* Determine the TCP destination port number */
	dest_port = tcp_seg_fd_ptr->dest_port;
	
	if (tcp_seg_fd_ptr->src_port != 20) 
		{
		org_addr = ip_address_create ("192.0.2.1");
		dest_addr = ip_address_create ("192.0.1.1");
		}
	if (tcp_seg_fd_ptr->src_port == 20) 
		{
		org_addr = ip_address_create ("192.0.1.1");	
		dest_addr = ip_address_create ("192.0.2.1");
		}
	org_addr2			= inet_address_create ("192.0.1.1",InetC_Addr_Family_v4);
	org_addr3			= inet_address_create ("192.0.2.1",InetC_Addr_Family_v4);
	
	/* delete the copy packets */
	op_pk_destroy( ipcopy_pkt1 );
	op_pk_destroy( copy_pkptr3 );
	
	/* Get the fields structure from the packet. */
	op_pk_nfd_access (ip_pkptr, "fields", &ip_dgram_fd_ptr);

	/* Set the protocol to MTCP */
	ip_dgram_fd_ptr->protocol = IpC_Protocol_Mtcp;

	/* Set the source address of the data. */
	ip_dgram_fd_ptr->src_addr.address.ipv4_addr = org_addr;
 	
	/* Set the destination address of the data. */
	ip_dgram_fd_ptr->dest_addr.address.ipv4_addr = dest_addr;
 	
	/* Determine the source address of the data. */
	org_addr1 = ip_dgram_fd_ptr->src_addr.address.ipv4_addr;
 	
	/* Determine the destination address of the data. */
	dest_addr1 = ip_dgram_fd_ptr->dest_addr.address.ipv4_addr;
 	
	FOUT	
	}

/*******************************************************************************/
/*																			   */
/* modify ip pkt from MH, change ack_num to the value of the input parameter,  */
/* other fields are untouched												   */
/*																			   */
/*******************************************************************************/

static  modify_MH_pkt( Packet * ip_pkptr, unsigned ack_num )
	{ 
	Packet * original_pkt;
	Packet * ipcopy_pkt;
	TcpT_Seg_Fields * tcp_seg_fd_ptr;

	
	FIN (modify_MH_pkt( ip_pkptr, ack_num ))
		
	printf("Entered modify MH packet. \n");
	
	// copy a new instance of the packet
	ipcopy_pkt = op_pk_copy( ip_pkptr );

	// extract the tcp packet out
	if (op_pk_nfd_get (ipcopy_pkt, "data", &original_pkt) == OPC_COMPCODE_FAILURE)
		{ 
		printf ("modify MH: Unable to get tcp pkt from IP datagram again.\n");
		FOUT 
		}

	// delete this packet
	op_pk_destroy( ipcopy_pkt );
	
	if (op_pk_nfd_access (original_pkt, "fields", &tcp_seg_fd_ptr) == OPC_COMPCODE_FAILURE)
		{ 
		printf ("modify MH: Unable to get data from TCP Segment to modify tcp pkt.\n");
		FOUT
		}
	
	/* set the TCP acknowledgement number */
	tcp_seg_fd_ptr->ack_num = ack_num;
	
	/* put tcp packet back */
	op_pk_nfd_set (ip_pkptr,"data",original_pkt);
	
	FOUT
	}


/////////////////////////////////////////////////////////////////////////////////
//																			   //
// Generate an ACK packet with rcv_wnd=0, this packet is used to force		   //
// the sender into persist mode												   //
//																			   //
/////////////////////////////////////////////////////////////////////////////////
static Packet * generate_persist_ACK()
	{
	Packet * seg_ptr;
	Packet * ipcopy_pkptr;
	TcpT_Seg_Fields * tcp_seg_fd_ptr;

	FIN(generate_persist_ACK())
		
	printf("entered generate persist ack\n");

	// duplicate the sample ACK packet
	seg_ptr = op_pk_copy (sample_MH_pkt );
	ipcopy_pkptr = op_pk_copy (copy_pkptr5);
	
	if (seg_ptr == OPC_NIL)
		{
		printf("ENCAP: NIL packet pointer in generate_persist_ACK()\n");

		FOUT
		}
	
	// get the tcp control fields
	if (op_pk_nfd_access (seg_ptr, "fields", &tcp_seg_fd_ptr) == OPC_COMPCODE_FAILURE)
		{
		printf ("Unable to get data from TCP Segment to get persist tcp pkt.\n");
		FOUT
		}
	
	// set the tcp control fields and make sure rcv_win=0
	tcp_seg_fd_ptr->ack_num = fh_last_seq_num ;
	tcp_seg_fd_ptr->seq_num = mh_last_seq_num ;
	tcp_seg_fd_ptr->rcv_win = 0;
	
	ack_num2 = tcp_seg_fd_ptr->ack_num ;
	printf("ACK_num2 is %d \n",ack_num2);
	
	transBeginCycle=1;
	generateACK = 0;
		
	// for debug
	printf( "structure of persist ACK pkt is: \n"); 
	tcp_seg_fdstruct_print(tcp_seg_fd_ptr); 
	
	if (op_pk_nfd_set (ipcopy_pkptr, "data", seg_ptr) == OPC_COMPCODE_FAILURE)
		{
		printf ("Unable to set data in IP datagram. \n");
		FOUT
		}
	
	FRET(ipcopy_pkptr);
	}	

/////////////////////////////////////////////////////////////////////////////////
//																			   //
// Generate an ACK packet with rcv_wnd=8760, this packet is used to bring      //
// the sender out of persist mode											   //
//																			   //
/////////////////////////////////////////////////////////////////////////////////
static Packet * generate_recovery_ACK()
	{
	Packet * seg_ptr;
	Packet * ipcopy_pkptr;
	TcpT_Seg_Fields * tcp_seg_fd_ptr;

	FIN(generate_recovery_ACK())
		
	printf("entered generate recovery ack\n");

	// duplicate the sample ACK packet
	seg_ptr = op_pk_copy (sample_MH_pkt );
	ipcopy_pkptr = op_pk_copy (copy_pkptr5);
	
	if (seg_ptr == OPC_NIL)
		{
		printf("ENCAP: NIL packet pointer in generate_recovery_ACK()\n");

		FOUT
		}
	
	// get the tcp control fields
	if (op_pk_nfd_access (seg_ptr, "fields", &tcp_seg_fd_ptr) == OPC_COMPCODE_FAILURE)
		{
		printf ("Unable to get data from TCP Segment to get recovery tcp pkt.\n");
		FOUT
		}
	
	// set the tcp control fields and make sure rcv_win=0
	tcp_seg_fd_ptr->ack_num = ack_num2 ;
	tcp_seg_fd_ptr->seq_num = mh_last_seq_num ;
	tcp_seg_fd_ptr->rcv_win = 8760;
	
	transBeginCycle= 0;
	generateACK = 0;
	
	// for debug
	printf( "structure of recovery ACK pkt is: \n"); 
	tcp_seg_fdstruct_print(tcp_seg_fd_ptr); 
	
	if (op_pk_nfd_set (ipcopy_pkptr, "data", seg_ptr) == OPC_COMPCODE_FAILURE)
		{
		printf ("Unable to set data in IP datagram. \n");
		FOUT
		}
		
	FRET(ipcopy_pkptr);
	}	

/****************************************************************************/
/* This function handle all the packets from Fixed Host.					*/
/* For each arriving packet, do the following:								*/
/* a) put it into a queue,													*/
/* b) record its seq_num and data_len										*/
/* c) schedule a timeout interrupt											*/
/* d) forward it to Mobile Host, so that it "thinks" the pkt is from FH		*/
/*																			*/
/****************************************************************************/

static void handle_Fixed_Host_Pkt( Packet * ip_pkptr)
{
Packet * copy_pkptr;
Packet * copy_pkptr2;
Packet * tcp_pkptr;
TcpT_Seg_Fields* tcp_seg_fd_ptr;

int 			syn;
int 			ack;

/* Make copies of the packet */
copy_pkptr = op_pk_copy(ip_pkptr);
copy_pkptr2 = op_pk_copy(ip_pkptr);


FIN (handle_Fixed_Host_Pkt( ip_pkptr ))

if (op_pk_nfd_get(copy_pkptr,"data", &tcp_pkptr) == OPC_COMPCODE_FAILURE)
	{ 
	printf ("Unable to get tcp packet from IP datagram.\n");
	FOUT
	}

op_pk_destroy (copy_pkptr);

if (op_pk_nfd_get(tcp_pkptr, "fields", &tcp_seg_fd_ptr) == OPC_COMPCODE_FAILURE)
	{ 
	printf ("Unable to get fields from TCP Segment.\n");
	FOUT
	}
ack = tcp_seg_fd_ptr->flags & TCPC_FLAG_ACK ? 1 : 0;
syn = tcp_seg_fd_ptr->flags & TCPC_FLAG_SYN ? 1 : 0;
fh_data_len = tcp_seg_fd_ptr->data_len ;

op_pk_destroy (tcp_pkptr);

// if this is a new packet, we
// mark down the next seq number from FH
if ( fh_last_seq_num < tcp_seg_fd_ptr->seq_num + fh_data_len  )
	{
	if ((fh_data_len == 1)&& ( isInit==1))
		{
		if ((isBrokenLink ==1) && (generateACK == 0))
			{
			printf("The MH is still disconnected \n");
			
			fh_seq_num = tcp_seg_fd_ptr->seq_num;
			printf("The FH last seq no for persist mode is %d \n",fh_seq_num);		
			
			generateACK=1;
			op_pk_destroy (ip_pkptr);
		
			FOUT
			}
		}
	else
		{
		fh_last_seq_num = tcp_seg_fd_ptr->seq_num + fh_data_len ;
		printf("The FH last seq no is %d, \n",fh_last_seq_num);
	
		// put this pkt into Queue
		putInQueue( copy_pkptr2, tcp_seg_fd_ptr->seq_num, tcp_seg_fd_ptr->data_len );
	
		// schedule a self interrupt to detect MH disconnection
		MH_rto = 0.6;
		op_intrpt_schedule_self( op_sim_time() + MH_rto, 0 );
		
		// for debug
		printf("After putting into queue, queue size is [%d], head=[%d], tail=[%d]\n",
queueSize(), queueHead, queueTail );
		}
	}
	
// if this is a new ack_num, update our record
if ( fh_last_ack_num < tcp_seg_fd_ptr->ack_num)
	fh_last_ack_num = tcp_seg_fd_ptr->ack_num;

op_pk_send_forced(ip_pkptr, TO_ENCAP_STRM); // SEND PK to ip_encap

FOUT
}	



/****************************************************************************/
/*																			*/
/* This function handle all the packets from Mobile Host.					*/
/* For each arriving packet, do the following:								*/
/* a) get the ack_num from the pkt, record this number						*/
/* b) record its seq_num and data_len										*/
/* c) in the packet, set ack_num = ack_num -1								*/
/* d) forward it to Fixed Host, so that it "thinks" the packet is from MH	*/
/*																			*/
/****************************************************************************/
static void handle_Mobile_Host_Pkt( Packet * ip_pkptr )
{ 
Packet * copy_pkptr;
Packet * copy_pkptr4;
Packet * tcp_pkptr;

TcpT_Seg_Fields * tcp_seg_fd_ptr;
int 			ack;
int 			syn;
int				fin;
copy_pkptr = op_pk_copy(ip_pkptr ); // for extracting tcp info


FIN (handle_Mobile_Host_Pkt( ip_pkptr ))

// get tcp packet from ip packet
if (op_pk_nfd_get (copy_pkptr, "data", &tcp_pkptr) == OPC_COMPCODE_FAILURE)
	{ 
	printf ("Unable to get tcp pkt from IP datagram.\n");
	FOUT
	}

op_pk_destroy( copy_pkptr);

// get control fields from tcp packet
if (op_pk_nfd_get (tcp_pkptr, "fields", &tcp_seg_fd_ptr) == OPC_COMPCODE_FAILURE)
	{ 
	printf ("Unable to get fields from TCP Segment.\n");
	FOUT
	}
ack = tcp_seg_fd_ptr->flags & TCPC_FLAG_ACK ? 1 : 0;
syn = tcp_seg_fd_ptr->flags & TCPC_FLAG_SYN ? 1 : 0;
fin = tcp_seg_fd_ptr->flags & TCPC_FLAG_FIN ? 1 : 0;
op_pk_destroy(tcp_pkptr);

// if this is a new seq_num, record this new number
if ( mh_last_seq_num < tcp_seg_fd_ptr->seq_num )
	mh_last_seq_num = tcp_seg_fd_ptr->seq_num;

// if this is a new ack
if ( mh_last_ack_num < tcp_seg_fd_ptr->ack_num)
	mh_last_ack_num = tcp_seg_fd_ptr->ack_num;

printf("The MH last ack no is %d \n",mh_last_ack_num);

if (ack_num3 == 0)
	{
	if (mh_last_ack_num < ack_num3+1460)
		{
		op_pk_send_forced(ip_pkptr, TO_ENCAP_STRM );
		FOUT
		}
	}
if ((fin == 1)&& (ack==1))
	{
	op_pk_send_forced(ip_pkptr, TO_ENCAP_STRM );
	FOUT
	}

	
ack_num3 = mh_last_ack_num;

// remove ACKed packets from queue
purgeFromQueue(	mh_last_ack_num);

// for debug
printf("After purging, queue size is [%d], head=[%d], tail=[%d]\n",
queueSize(), queueHead, queueTail );

if ((queueSize() == 0) && (ack_num3 != 0) && (mh_last_ack_num == fh_last_seq_num +1))
	{
	op_pk_send_forced(ip_pkptr, TO_ENCAP_STRM );
	FOUT
	}

// Obtain the sample ACK pkt from mobile host in order to duplicate ACK pkt later
// This only need to be done once at the very beginning of the connection
if ((isInit== 0)&&( syn==0)&&( ack== 1)&& (tcp_seg_fd_ptr->data_len == 0 )) 
	{ 
	printf("init client sample pkt\n" );
	isInit=1;

	// get tcp packet from duplicated packet.
	copy_pkptr4 = op_pk_copy (ip_pkptr);
	copy_pkptr5 = op_pk_copy (ip_pkptr);
	
	if (op_pk_nfd_get (copy_pkptr4, "data", &tcp_pkptr) == OPC_COMPCODE_FAILURE)
		{ 
		printf ("Unable to get tcp pkt from IP datagram again.\n");
		FOUT 
		}

	sample_MH_pkt = op_pk_copy ( tcp_pkptr ); // make a sample of MH tcp pkt
	
	op_pk_destroy (copy_pkptr4);
	op_pk_destroy(tcp_pkptr);
	}

if (ack_num2 !=0)
	{
	
	if (mh_last_ack_num<=ack_num2)
		{
		printf("Deleting unneeded ACKs \n");
		op_pk_destroy(ip_pkptr);
		
		FOUT
		}
	if (mh_last_ack_num == ack_num2 + 1460)
		{
		printf("Sending first ACK after recovery \n");
		op_pk_send (modify_MH_pkt(ip_pkptr, mh_last_ack_num -1), TO_ENCAP_STRM);
		FOUT
		}
	}

op_pk_send_forced(modify_MH_pkt(ip_pkptr, mh_last_ack_num -1), TO_ENCAP_STRM );

FOUT
}


/*****************************************************************************/
/*																			 */
/* Main dispatcher of handling packets										 */
/* packets will be dispatched to proper handling functions					 */
/*																			 */
/*****************************************************************************/
static void myTest2 (Packet * ip_pkptr)
	{
	IpT_Dgram_Fields* ip_dgram_fd_ptr;	
	FIN (myTest2(ip_pkptr))
		
	// get info from pkt
	analyse_incoming_pkt(ip_pkptr );
	
	// handle fixed host packet
	if (org_addr1 == ip_address_create ("192.0.1.1"))
		{
		/* Get the fields structure from the packet. */
		op_pk_nfd_access (ip_pkptr, "fields", &ip_dgram_fd_ptr);
		
		/* Set the source address of the data. */
		ip_dgram_fd_ptr->src_addr = org_addr2;
 		
		/* Set the destination address of the data. */
		ip_dgram_fd_ptr->dest_addr = org_addr3;
 			
		handle_Fixed_Host_Pkt (ip_pkptr );
		
		FOUT
		}
				
	if (org_addr1 == ip_address_create ("192.0.2.1"))
		{
		/* Get the fields structure from the packet. */
		op_pk_nfd_access (ip_pkptr, "fields", &ip_dgram_fd_ptr);
		
		/* Set the source address of the data. */
		ip_dgram_fd_ptr->src_addr = org_addr3;
 		
		/* Set the destination address of the data. */
		ip_dgram_fd_ptr->dest_addr = org_addr2;
 		
		handle_Mobile_Host_Pkt( ip_pkptr );
			
		FOUT	
		}
	}

/* End of Function Block */


/* End of Function Block */

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void sh_adaptive_mtcp_1 (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype _op_sh_adaptive_mtcp_1_init (int * init_block_ptr);
	VosT_Address _op_sh_adaptive_mtcp_1_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype, int);
	void _op_sh_adaptive_mtcp_1_diag (OP_SIM_CONTEXT_ARG_OPT);
	void _op_sh_adaptive_mtcp_1_terminate (OP_SIM_CONTEXT_ARG_OPT);
	void _op_sh_adaptive_mtcp_1_svar (void *, const char *, void **);


	VosT_Obtype Vos_Define_Object_Prstate (const char * _op_name, unsigned int _op_size);
	VosT_Address Vos_Alloc_Object_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype _op_ob_hndl);
	VosT_Fun_Status Vos_Poolmem_Dealloc_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Address _op_ob_ptr);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
sh_adaptive_mtcp_1 (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (sh_adaptive_mtcp_1 ());
		{
		/* Temporary Variables */
		double		pk_size;
		double		ete_delay;
		
		
		/* End of Temporary Variables */


		FSM_ENTER ("sh_adaptive_mtcp_1")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (Wait) enter executives **/
			FSM_STATE_ENTER_UNFORCED (0, "Wait", state0_enter_exec, "sh_adaptive_mtcp_1 [Wait enter execs]")

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (1,"sh_adaptive_mtcp_1")


			/** state (Wait) exit executives **/
			FSM_STATE_EXIT_UNFORCED (0, "Wait", "sh_adaptive_mtcp_1 [Wait exit execs]")


			/** state (Wait) transition processing **/
			FSM_PROFILE_SECTION_IN ("sh_adaptive_mtcp_1 [Wait trans conditions]", state0_trans_conds)
			FSM_INIT_COND (PK_ARRIVE)
			FSM_TEST_COND (TIME_OUT)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("Wait")
			FSM_PROFILE_SECTION_OUT (state0_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "PK_ARRIVE", "", "Wait", "handle", "sh_adaptive_mtcp_1 [Wait -> handle : PK_ARRIVE / ]")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "TIME_OUT", "", "Wait", "time_out", "sh_adaptive_mtcp_1 [Wait -> time_out : TIME_OUT / ]")
				FSM_CASE_TRANSIT (2, 0, state0_enter_exec, ;, "default", "", "Wait", "Wait", "sh_adaptive_mtcp_1 [Wait -> Wait : default / ]")
				}
				/*---------------------------------------------------------*/



			/** state (INIT) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (1, "INIT", "sh_adaptive_mtcp_1 [INIT enter execs]")
				FSM_PROFILE_SECTION_IN ("sh_adaptive_mtcp_1 [INIT enter execs]", state1_enter_exec)
				{
				/** Register using OMS Process Registry.					**/
				
				/* Obtain the neccessary objids.							*/
				own_objid = op_id_self ();
				printf ("MTCP object id is %d \n", own_objid);
				
				own_node_objid = op_topo_parent (own_objid);
				
				/* Obtain the mtcp process's prohandle.					*/
				own_prohandle = op_pro_self ();
				
				/* Obtain the name of the process. It is the				*/
				/* "process model" attribute of the module.					*/
				op_ima_obj_attr_get_str (own_objid, "process model", 20, proc_model_name);
				
				/* Register the process in the model-wide registry.			*/
				own_process_record_handle = (OmsT_Pr_Handle) oms_pr_process_register (own_node_objid, own_objid, 
										own_prohandle, proc_model_name);
				
				/* Register the protocol attribute in the registry.			*/
				oms_pr_attr_set (own_process_record_handle, "protocol",	OMSC_PR_STRING,	"mtcp",  OPC_NIL);
				
				/* Schedule a self interrupt for this process at	*/
				/* the current time to allow lower layer processes	*/
				/* to register in process registry.					*/
				op_intrpt_schedule_self (op_sim_time (), 0);
				
				/* Set the protocol type.							*/
				higher_layer_protocol_type = IpC_Protocol_Mtcp;
				
				/* Register this higher layer protocol label with	*/
				/* the given higher layer protocol type.			*/
				Ip_Higher_Layer_Protocol_Register ("mtcp", &higher_layer_protocol_type);
				
				/* Initilaize the statistic handles to keep	*/
				/* track of traffic sinked by this process.	*/
				bits_rcvd_stathandle 		= op_stat_reg ("Traffic Sink.Traffic Received (bits)",			OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				bitssec_rcvd_stathandle 	= op_stat_reg ("Traffic Sink.Traffic Received (bits/sec)",		OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				pkts_rcvd_stathandle 		= op_stat_reg ("Traffic Sink.Traffic Received (packets)",		OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				pktssec_rcvd_stathandle 	= op_stat_reg ("Traffic Sink.Traffic Received (packets/sec)",	OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				ete_delay_stathandle		= op_stat_reg ("Traffic Sink.End-to-End Delay (seconds)",		OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				
				bits_rcvd_gstathandle 		= op_stat_reg ("Traffic Sink.Traffic Received (bits)",			OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				bitssec_rcvd_gstathandle 	= op_stat_reg ("Traffic Sink.Traffic Received (bits/sec)",		OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				pkts_rcvd_gstathandle 		= op_stat_reg ("Traffic Sink.Traffic Received (packets)",		OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				pktssec_rcvd_gstathandle 	= op_stat_reg ("Traffic Sink.Traffic Received (packets/sec)",	OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				ete_delay_gstathandle		= op_stat_reg ("Traffic Sink.End-to-End Delay (seconds)",		OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				}
				FSM_PROFILE_SECTION_OUT (state1_enter_exec)

			/** state (INIT) exit executives **/
			FSM_STATE_EXIT_FORCED (1, "INIT", "sh_adaptive_mtcp_1 [INIT exit execs]")


			/** state (INIT) transition processing **/
			FSM_TRANSIT_FORCE (0, state0_enter_exec, ;, "default", "", "INIT", "Wait", "sh_adaptive_mtcp_1 [INIT -> Wait : default / ]")
				/*---------------------------------------------------------*/



			/** state (handle) enter executives **/
			FSM_STATE_ENTER_FORCED (2, "handle", state2_enter_exec, "sh_adaptive_mtcp_1 [handle enter execs]")
				FSM_PROFILE_SECTION_IN ("sh_adaptive_mtcp_1 [handle enter execs]", state2_enter_exec)
				{
				Packet * pkptr;
				int			intrpt_type;
				int			input_strm;
				
				/* Obtain the incoming packet.	*/
				intrpt_type = op_intrpt_type ();
				input_strm = op_intrpt_strm();
				
				
				if (intrpt_type == OPC_INTRPT_STRM && input_strm == FROM_ENCAP_STRM )
					{
					pkptr = op_pk_get(input_strm);
								
					if (pkptr ==OPC_NIL)
						{
						printf("Empty packet from ip_encap\n");
						}
					else
						{
						/* Caclulate metrics to be updated.		*/
						pk_size = (double) op_pk_total_size_get (pkptr);
						ete_delay = op_sim_time () - op_pk_creation_time_get (pkptr);
				
						/* Update local statistics.				*/
						op_stat_write (bits_rcvd_stathandle, 		pk_size);
						op_stat_write (pkts_rcvd_stathandle, 		1.0);
						op_stat_write (ete_delay_stathandle, 		ete_delay);
				
						op_stat_write (bitssec_rcvd_stathandle, 	pk_size);
						op_stat_write (bitssec_rcvd_stathandle, 	0.0);
						op_stat_write (pktssec_rcvd_stathandle, 	1.0);
						op_stat_write (pktssec_rcvd_stathandle, 	0.0);
				
						/* Update global statistics.	*/
						op_stat_write (bits_rcvd_gstathandle, 		pk_size);
						op_stat_write (pkts_rcvd_gstathandle, 		1.0);
						op_stat_write (ete_delay_gstathandle, 		ete_delay);
				
						op_stat_write (bitssec_rcvd_gstathandle, 	pk_size);
						op_stat_write (bitssec_rcvd_gstathandle, 	0.0);
						op_stat_write (pktssec_rcvd_gstathandle, 	1.0);
						op_stat_write (pktssec_rcvd_gstathandle, 	0.0);
						
						/* process the packet */
						myTest2(pkptr);
						}
					}
				
				
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** state (handle) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "handle", "sh_adaptive_mtcp_1 [handle exit execs]")


			/** state (handle) transition processing **/
			FSM_TRANSIT_FORCE (0, state0_enter_exec, ;, "default", "", "handle", "Wait", "sh_adaptive_mtcp_1 [handle -> Wait : default / ]")
				/*---------------------------------------------------------*/



			/** state (time_out) enter executives **/
			FSM_STATE_ENTER_FORCED (3, "time_out", state3_enter_exec, "sh_adaptive_mtcp_1 [time_out enter execs]")
				FSM_PROFILE_SECTION_IN ("sh_adaptive_mtcp_1 [time_out enter execs]", state3_enter_exec)
				{
				int			intrpt_type;
				int 		intrpt_code;
				
				
				/* Obtain the incoming interrupt.	*/
				intrpt_type = op_intrpt_type ();
				intrpt_code = op_intrpt_code ();
				
				if ((intrpt_type == OPC_INTRPT_REMOTE ) && (intrpt_code ==101) && (transBeginCycle ==0) && (isInit ==1))
					{
					// generate persist mode packet
					Packet* persist_ACK = generate_persist_ACK();
					
					// send persist mode packet
					op_pk_send_forced(persist_ACK, TO_ENCAP_STRM );
					
					printf("*******Link is disconnected now.******** \n");
					transMode = 1;
					isBrokenLink = 1;
						
					// for debug
					printf( stderr, "send ACK for persist mode at %lf*********\n", op_sim_time() );
					}
				
				if ((intrpt_type == OPC_INTRPT_REMOTE ) && (intrpt_code ==102) && (transBeginCycle ==1))
					{
					printf("*******Link is reconnected now.******** \n");
					resendPackets();
					
					// generate recovery ACK
					Packet* reconnect_ACK = generate_recovery_ACK();
						
					// send persist mode packet
					op_pk_send(reconnect_ACK, TO_ENCAP_STRM);
					
					transMode = 0;
					isBrokenLink = 0;
					
					
					}
					
				}
				FSM_PROFILE_SECTION_OUT (state3_enter_exec)

			/** state (time_out) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "time_out", "sh_adaptive_mtcp_1 [time_out exit execs]")


			/** state (time_out) transition processing **/
			FSM_TRANSIT_FORCE (0, state0_enter_exec, ;, "default", "", "time_out", "Wait", "sh_adaptive_mtcp_1 [time_out -> Wait : default / ]")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (1,"sh_adaptive_mtcp_1")
		}
	}




void
_op_sh_adaptive_mtcp_1_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
_op_sh_adaptive_mtcp_1_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (_op_sh_adaptive_mtcp_1_terminate ())


	/* No Termination Block */

	Vos_Poolmem_Dealloc_MT (OP_SIM_CONTEXT_THREAD_INDEX_COMMA pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in _op_sh_adaptive_mtcp_1_svar function. */
#undef bits_rcvd_stathandle
#undef bitssec_rcvd_stathandle
#undef pkts_rcvd_stathandle
#undef pktssec_rcvd_stathandle
#undef ete_delay_stathandle
#undef bits_rcvd_gstathandle
#undef bitssec_rcvd_gstathandle
#undef pkts_rcvd_gstathandle
#undef pktssec_rcvd_gstathandle
#undef ete_delay_gstathandle
#undef own_objid
#undef own_node_objid
#undef own_process_record_handle
#undef proc_model_name
#undef own_prohandle
#undef higher_layer_protocol_type
#undef instrm_from_network
#undef record_handle_list_size

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
_op_sh_adaptive_mtcp_1_init (int * init_block_ptr)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (_op_sh_adaptive_mtcp_1_init (init_block_ptr))

	obtype = Vos_Define_Object_Prstate ("proc state vars (sh_adaptive_mtcp_1)",
		sizeof (sh_adaptive_mtcp_1_state));
	*init_block_ptr = 2;

	FRET (obtype)
	}

VosT_Address
_op_sh_adaptive_mtcp_1_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype obtype, int init_block)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	sh_adaptive_mtcp_1_state * ptr;
	FIN_MT (_op_sh_adaptive_mtcp_1_alloc (obtype))

	ptr = (sh_adaptive_mtcp_1_state *)Vos_Alloc_Object_MT (VOS_THREAD_INDEX_COMMA obtype);
	if (ptr != OPC_NIL)
		{
		ptr->_op_current_block = init_block;
#if defined (OPD_ALLOW_ODB)
		ptr->_op_current_state = "sh_adaptive_mtcp_1 [INIT enter execs]";
#endif
		}
	FRET ((VosT_Address)ptr)
	}



void
_op_sh_adaptive_mtcp_1_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	sh_adaptive_mtcp_1_state		*prs_ptr;

	FIN_MT (_op_sh_adaptive_mtcp_1_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (sh_adaptive_mtcp_1_state *)gen_ptr;

	if (strcmp ("bits_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->bits_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("bitssec_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->bitssec_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("pkts_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pkts_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("pktssec_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pktssec_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("ete_delay_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ete_delay_stathandle);
		FOUT
		}
	if (strcmp ("bits_rcvd_gstathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->bits_rcvd_gstathandle);
		FOUT
		}
	if (strcmp ("bitssec_rcvd_gstathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->bitssec_rcvd_gstathandle);
		FOUT
		}
	if (strcmp ("pkts_rcvd_gstathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pkts_rcvd_gstathandle);
		FOUT
		}
	if (strcmp ("pktssec_rcvd_gstathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pktssec_rcvd_gstathandle);
		FOUT
		}
	if (strcmp ("ete_delay_gstathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ete_delay_gstathandle);
		FOUT
		}
	if (strcmp ("own_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->own_objid);
		FOUT
		}
	if (strcmp ("own_node_objid" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->own_node_objid);
		FOUT
		}
	if (strcmp ("own_process_record_handle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->own_process_record_handle);
		FOUT
		}
	if (strcmp ("proc_model_name" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->proc_model_name);
		FOUT
		}
	if (strcmp ("own_prohandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->own_prohandle);
		FOUT
		}
	if (strcmp ("higher_layer_protocol_type" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->higher_layer_protocol_type);
		FOUT
		}
	if (strcmp ("instrm_from_network" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->instrm_from_network);
		FOUT
		}
	if (strcmp ("record_handle_list_size" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->record_handle_list_size);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

